#include "PushSwitch.h"
#define SWITCH_MAX 3
static const int Button[SWITCH_MAX] = {3, 4, 5};
PushSwitch::PushSwitch()
{
    for (int i=0; i<3; i++) {
        pinMode(Button[i], INPUT);
        digitalWrite(Button[i], HIGH);//pull up
    }
    mPushed = false ;
}
int PushSwitch::procPushSwitch()
{
    if( mPushed ) {
        //最後に押されてから、一定期間は無視する
        if( ( millis() - mLastTick ) > 500 ) {
            mPushed = false ;
            return -1 ;
        }
    }
    for( int i = 0 ; i < SWITCH_MAX ; i ++ ) {
        if( digitalRead(Button[i])== LOW ) {
            mPushed = true ;
            mLastTick = millis() ;
            return i ;
        }
    }
}
/*
for (int i = 0; i < 512; i++)
    EEPROM.write(i, 0);
    
  value = EEPROM.read(address);

*/
