#ifndef Histry_H
#define Histry_H

//データ配列の型
typedef unsigned char HISTRY_DATA_TYPE ;

class Histry
{
private:
    int mPtr ;      //データ書き込みポインタ.
    int mMax ;      //データの最大個数.
    int mHowMany ;  //取得したデータの個数.
    HISTRY_DATA_TYPE* mData ;    //データへのポインタ.
    unsigned long mSum ;     //データの総和.
public:
    Histry();
    void setBuffer( int bufSize, HISTRY_DATA_TYPE* bufPtr );
    void init();
    void entryData( unsigned char data ) ;
    unsigned long getSum() ;
    int howMany() ;
    int getAverage() ;
};
#endif	// Histry_H

