#include "Histry.h"

static int incrimentHistryPtr( int Ptr, int Max );
static int incrimentNumOfData( int Ptr, int Max );

/******************************************************************************
機能要約 コンストラクタ
機能
引き数
戻り値
注意
******************************************************************************/
Histry::Histry()
{
    ::init();
}
/******************************************************************************
機能要約 初期化
機能
引き数
戻り値
注意
******************************************************************************/
void Histry::init()
{
    mSum = 0 ;
    mHowMany = 0 ;
    mPtr = 0 ;
}
/******************************************************************************
機能要約 バッファのセット
機能
引き数
戻り値
注意
******************************************************************************/
void Histry::setBuffer( int bufSize, HISTRY_DATA_TYPE* bufPtr )
{
    init();
    mData = bufPtr ;
    mMax = bufSize ;
    for( int i = 0 ; i < mMax ; i ++ ) {
        mData[ i ] = 0 ;
    }
}
/******************************************************************************
機能要約 データ追加
機能
引き数
戻り値
注意
******************************************************************************/
void Histry::entryData( unsigned char data )
{
    mSum -= mData[ mPtr ] ;
    mSum += data ;

    mData[ mPtr ] = data ;

    mPtr = incrimentHistryPtr( mPtr, mMax ) ;
    mHowMany = incrimentNumOfData( mHowMany, mMax ) ;
}
/******************************************************************************
機能要約 合計を求める
機能
引き数
戻り値
注意
******************************************************************************/
unsigned long Histry::getSum()
{
    return mSum ;
}
/******************************************************************************
機能要約 データ数を求める
機能
引き数
戻り値
注意
******************************************************************************/
int Histry::howMany()
{
    return mHowMany ;
}
/******************************************************************************
機能要約 平均を求める
機能
引き数
戻り値
注意
******************************************************************************/
int Histry::getAverage()
{
    return( mSum / mHowMany ) ;
}
/******************************************************************************
機能要約
機能
引き数
戻り値
注意
******************************************************************************/
static int incrimentHistryPtr( int Ptr, int Max )
{
    Ptr ++ ;
    if( Ptr >= Max ) {
        Ptr = 0 ;
    }
    return Ptr ;
}
/******************************************************************************
機能要約
機能
引き数
戻り値
注意
******************************************************************************/
static int incrimentNumOfData( int Ptr, int Max )
{
    Ptr ++ ;
    if( Ptr >= Max ) {
        Ptr = Max ;
    }
    return Ptr ;
}
